
#include "FiveWin.ch"
#include "easyrep.ch"

//----------------------------------------------------------------------------//

function Main()

   local aStates, aCust, aRow, nAt, nStateCol
   local oDlg, oFont, oBrwStates, oBrwCust, oBtn

   USE STATES
   aStates  := FW_DbfToArray()
   USE CUSTOMER
   nStateCol := FieldPos( "state" )
   aCust    := FW_DbfToArray()
   CLOSE CUSTOMER

   AEval( aStates, { |a| AAdd( a, Array( 0 ) ) } )
   for each aRow in aCust
      nAt   := AScan( aStates, { |a| a[ 1 ] == aRow[ nStateCol ] } )
      if nAt > 0
         AAdd( aStates[ nAt, 3 ], aRow )
      endif
   next

   DEFINE FONT oFont NAME "TAHOMA" SIZE 0,-12
   DEFINE DIALOG oDlg SIZE 1000,600 PIXEL TRUEPIXEL FONT oFont
  
  	@ 0,0 ;
      BUTTON oBtn ;
      PROMPT "EasyReport" ;
        SIZE 100, 24 ;
      ACTION DruckListe( aStates ) ;
          OF oDlg ;
       PIXEL

   @ 40, 20 XBROWSE oBrwStates SIZE 270,-20 PIXEL OF oDlg ;
      DATASOURCE aStates ;
      COLUMNS 1, 2 HEADERS "CODE","NAME" ;
      CELL LINES NOBORDER

   WITH OBJECT oBrwStates
      :bChange := { || oBrwCust:aArrayData := oBrwStates:aRow[ 3 ], ;
                       oBrwCust:GoTop(), oBrwCust:Refresh() }
      :CreateFromCode()
   END

   @ 40,290 XBROWSE oBrwCust SIZE -20,-20 PIXEL OF oDlg ;
      DATASOURCE aStates[ 1, 3 ] ;
      COLUMNS 2,3,5,6 HEADERS "FIRST","LAST","CITY","STATE" ;
      CELL LINES NOBORDER

   WITH OBJECT oBrwCust
      :CreateFromCode()
   END

   ACTIVATE DIALOG oDlg CENTERED
   RELEASE FONT oFont

return nil
//-----------------------

FUNCTION DruckListe( aStates )

	local oVRD
	local lPreview 		:= .t.
	local cDruckerName 	:= ""
	local cTemp := ""
	local nNr := 1
	local nSeite := 0
	local nIdx := 0
	local I := 0
	local aTemp := {}
   *----------------------------------------------------------
	
	TPreview():lListViewHide := .T.

	EASYREPORT oVRD NAME ".\xVrd\states.vrd"  PREVIEW  lPreview TO cDruckerName PRINTDIALOG IIF( lPreview, .F., .F. ) MODAL

	PRINTAREA 1 OF oVRD   ;
               ITEMIDS    { 101, 102 } ;
               ITEMVALUES { "Report with array", dtoc(  date() )  }
	
	PRINTAREA 2 OF oVRD;
               ITEMIDS    { 100 } ;
               ITEMVALUES { "Anyone have a sample how i can relationate 2 arrays (masterdata/detail) and pass to fastreport?" }
	
	PRINTAREA 7 OF oVRD
	
	FOR nIdx := 1 to len( aStates ) 
	
		PRINTAREA 3 OF oVRD ;
               ITEMIDS    { 100, 101,  102 } ;
               ITEMVALUES { "c:\fwh\samples\xVrd\kreis.jpg", aStates[ nIdx, 1 ] ,;
               aStates[ nIdx, 2 ] }
	
		aTemp := aStates[ nIdx, 3 ]
	
		FOR I:= 1 to len( aTemp )
				PRINTAREA 4 OF oVRD   ;
		               ITEMIDS    { 102, 103 ,104, 105 } ;
		               ITEMVALUES { aTemp[ I,2  ], aTemp[ I,3  ],aTemp[ I,4  ],aTemp[ I,5  ]   }
			
		  			IF oVRD:nNextRow > oVRD:nPageBreak
			            nSeite := nSeite + 1 
		            
			            PRINTAREA 5 OF oVRD   ;
			               ITEMIDS    { 100 } ;
			               ITEMVALUES { ALLTRIM( str( nSeite ) ) }
			            
			            PAGEBREAK oVRD
			            PRINTAREA 6 OF oVRD
			            PRINTAREA 2 OF oVRD
			            PRINTAREA 7 OF oVRD   ;
			               ITEMIDS    { 120 } ;
			               ITEMVALUES { dtoc( date() ) }
		         ENDIF
		 
		NEXT	
 
	NEXT
  
	oVRD:End()

	RETURN NIL
	
	//----------------------------------------------------------------------------//
	